/******************************/
/* LN^f[^ϊ */
/******************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	CHRWIDTH	40
#define	CHRHEIGHT	20
#define	MAXCHARA	64

#define	DTNUM		56

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;
	FILE	*patfp;

	int		pixel[CHRWIDTH][CHRHEIGHT][MAXCHARA];
	int		dt[DTNUM][MAXCHARA];

	int		width,height;
	int		x,y,z,c;
	int		i,j;
	int		sft;
	int		a0,a1;
	int		cnum;
	int		dflag;

	if (argc != 4 && argc != 5) {
		fprintf(stderr, "Usage: convchara infile outfile cha_number [-d]\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	cnum = atoi(argv[3]);

	dflag = 0;
	if (argc == 5) {
		if (strcmp(argv[4],"-d") == 0) {
			dflag = 1;
		} else {
			printf("Illigal Parameter:%s\n",argv[4]);
			exit(1);
		}
	}

	if (dflag == 1) {
		for (j = 0;j < 0x1c00;j ++) {
			if ( (a0 = fgetc(infp)) == EOF) {
				break;
			}
			fputc(a0,outfp);
		}
	}

	for (z = 0;z < MAXCHARA;z ++) {
		for (y = 0;y < CHRHEIGHT;y ++) {
			for (x = 0;x < CHRWIDTH;x ++) {
				pixel[x][y][z] = 0x00;
			}
		}
	}

	z = 0;
	y = 0;
	x = 0;
	c = 0x0a;
	while ( (a0 = fgetc(infp)) != EOF) {

		sft = 0x80;
		for (i = 0;i < 8;i ++) {
			a1 = ( (a0 & sft) != 0x00) ? c : 0x08;
			pixel[x+i][y][z] |= a1;
			sft /= 2;
		}

		x += 8;
		if (x >= CHRWIDTH) {
			x = 0;
			y ++;
			if (y >= CHRHEIGHT) {
				y = 0;
				if (c == 0x0a) {
					c = 0x0c;
				} else {
					c = 0x0a;
					if (dflag == 1) {
						for (j = 0;j < DTNUM;j ++) {
							if ( (a0 = fgetc(infp)) == EOF) {
								break;
							}
							dt[j][z] = a0;
						}
					}
					z ++;

					if (z >= cnum) {
						break;
					}
				}
			}
		}
	}

	for (z = 0;z < cnum;z ++) {

		for (x = 0;x < CHRWIDTH;x += 8) {
			for (y = 0;y < CHRHEIGHT;y ++) {

				a1 = 0;
				for (i = 0;i < 8;i ++) {
					a0 = ( ((pixel[x+i][y][z] & 0x02) != 0x00) ? 0x01 : 0x00);
					a1 = a1 * 2 + a0;
				}
				fputc(a1,outfp);

				a1 = 0;
				for (i = 0;i < 8;i ++) {
					a0 = ( ((pixel[x+i][y][z] & 0x04) != 0x00) ? 0x01 : 0x00);
					a1 = a1 * 2 + a0;
				}
				fputc(a1,outfp);

			}
		}

		if (dflag == 1) {
			for (j = 0;j < DTNUM;j ++) {
				fputc(dt[j][z],outfp);
			}
		}
	}

	fclose(outfp);
	fclose(infp);

	return(0);
}

