#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	MAXFLLEN	32
#define	MAXWIDTH	640
#define	MAXHEIGHT	600

int main(int argc, char **argv)
{
	FILE	*infp[2];
	FILE	*outfp;
	FILE	*outfp2;

	unsigned char	pixel[MAXWIDTH][MAXHEIGHT];

	int		width,height;
	int		a0,a1,a2,a3;
	int		x,y;
	int		i,j;
	int		st;
	int		col,colsr;
	int		ysr;
	int		yoff;
	int		fnum;
	int		outhigh,eqlen;
	int		outdt4b;
	int		d0,d1;
	unsigned char	yflag[8][MAXHEIGHT];

	if (argc != 5) {
		fprintf(stderr, "Usage: convend leftfile rightfile outfile1 outfile2\n");
		exit(1);
	}

/* open files */

	if ((infp[1] = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((infp[0] = fopen(argv[2], "rb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	if ((outfp = fopen(argv[3], "wb")) == NULL) {
		perror(argv[3]);
		exit(1);
	}

	if ((outfp2 = fopen(argv[4], "wb")) == NULL) {
		perror(argv[4]);
		exit(1);
	}

	fgetc(infp[1]);				/* JnAhX */
	fgetc(infp[1]);				/* JnAhX */
	a0 = fgetc(infp[1]);		/* YTCY */
	a1 = fgetc(infp[1]);		/* YTCY */

	height = (a1*0x100 + a0) / 3;

	width = fgetc(infp[1]) * 8;	/* XTCY */
	fgetc(infp[1]);				/* Jnv[igpj */

	fgetc(infp[0]);				/* JnAhX`Jnv[ */
	fgetc(infp[0]);
	fgetc(infp[0]);
	fgetc(infp[0]);
	fgetc(infp[0]);
	fgetc(infp[0]);

	for (y = 0;y < height*3;y ++) {
		for (x = 0;x < width*2;x ++) {
			pixel[x][y] = 0x08;
		}
	}

	for (fnum = 0;fnum < 2;fnum ++) {
		col = 0x01;
		for (y = 0;y < height;) {
			a0 = fgetc(infp[fnum]);

			if (a0 >= 0x80) {
				a0 -= 0x80;
				if (a0 >= 0x54) {
					colsr = 0x04;
					a0 -= 0x54;
				} else if (a0 >= 0x2a) {
					colsr = 0x02;
					a0 -= 0x2a;
				} else {
					colsr = 0x01;
				}

				ysr = fgetc(infp[fnum]);

				for (x = 0;x < width;x ++) {
					if ( (pixel[x][ysr] & colsr) != 0) {
						pixel[x][y] |= col;
					} else {
						pixel[x][y] &= (col ^ 0xff);
					}
				}

				for (x = 0;x < a0*8;) {
					a1 = fgetc(infp[fnum]);
					if (a1 >= 0xa0) {
						a1 -= 0xa0;
						a2 = 3;
					} else if (a1 >= 0x50) {
						a1 -= 0x50;
						a2 = 2;
					} else {
						a2 = 1;
					}

					for (i = 0;i < a2;i ++) {
						a3 = fgetc(infp[fnum]);
						st = 0x80;
						for (j = 0;j < 8;j ++) {
							if ( (a3 & st) != 0) {
								pixel[a1*8+j][y] |= col;
							} else {
								pixel[a1*8+j][y] &= (col ^ 0xff);
							}
							st /= 2;
						}
						a1 ++;
						x += 8;
					}

				}

			} else {

				for (x = 0;x < width;) {

					if (x != 0) {
						a0 = fgetc(infp[fnum]);
					}

					if (a0 >= 0x80) {
						a0 -= 0x80;
						for (i = 0;i < a0;i ++) {
							a1 = fgetc(infp[fnum]);
							st = 0x80;
							for (j = 0;j < 8;j ++) {
								if ( (a1 & st) != 0) {
									pixel[x+j][y] |= col;
								} else {
									pixel[x+j][y] &= (col ^ 0xff);
								}
								st /= 2;
							}
							x += 8;
						}
					} else {
						a1 = fgetc(infp[fnum]);
						for (i = 0;i < a0;i ++) {
							st = 0x80;
							for (j = 0;j < 8;j ++) {
								if ( (a1 & st) != 0) {
									pixel[x+j][y] |= col;
								} else {
									pixel[x+j][y] &= (col ^ 0xff);
								}
								st /= 2;
							}
							x += 8;
						}
					}

				}

			}

			if (col == 0x04) {
				col = 0x01;
				y ++;
			} else {
				col *= 2;
			} 

		}

		if (fnum == 0) {
			for (y = 0;y < height;y ++) {
				for (x = 0;x < width;x ++) {
					pixel[x+width][y] = pixel[x][y];
				}
			}
		}

	}

	yoff = height*2;
	for (y = 0;y < height;y ++) {
		for (x = 0;x < width*2;x ++) {
			a0 = pixel[x][y];
			a0 = ( (a0 & 0x04) != 0x00) ? 0x0e : 0x08;
			pixel[x][y+yoff] = a0;
		}
	}

	yoff = height*1;
	for (y = 0;y < height;y ++) {
		for (x = 0;x < width*2;x ++) {
			a0 = pixel[x][y];
			a0 = ( (a0 & 0x02) != 0x00) ? 0x0e : 0x08;
			pixel[x][y+yoff] = a0;
		}
	}

	yoff = 0;
	for (y = 0;y < height;y ++) {
		for (x = 0;x < width*2;x ++) {
			a0 = pixel[x][y];
			a0 = ( (a0 & 0x01) != 0x00) ? 0x0e : 0x08;
			pixel[x][y+yoff] = a0;
		}
	}


/* ŏ200Ciɉʂɕ\Ăj */

	for (y = 0;y < height;y ++) {
		for (x = 0;x < width*2;x += 8) {

			for (i = 0;i < 8;i ++) {
				a1 = ( (pixel[x+i][y] != 0x08) ? 0x01 : 0x00);
				a0 = a0 * 2 + a1;
			}
			fputc(a0,outfp);
		}
	}


/* 400CiXN[j */

	for (y = height;y < height*3;y ++) {
		for (x = 0;x < width*2;x += 8) {

			for (i = 0;i < 8;i ++) {
				a1 = ( (pixel[x+i][y] != 0x08) ? 0x01 : 0x00);
				a0 = a0 * 2 + a1;
			}
			fputc(a0,outfp2);
		}
	}


	fclose(infp[0]);
	fclose(infp[1]);

	fclose(outfp);
	fclose(outfp2);

	return(0);
}

