#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	CHRWIDTH	16
#define	CHRHEIGHT	8
#define	MAXCHARA	96

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;

	int		pixel[CHRWIDTH][CHRHEIGHT][MAXCHARA];

	int		width,height;
	int		x,y,z;
	int		i,j;
	int		sft;
	int		a0,a1,c;
	int		cnum;

	if (argc != 3) {
		fprintf(stderr, "Usage: convfont infile outfile\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}


/* 16x8 2v[LN^ */

	cnum = 16;

	for (z = 0;z < cnum;z ++) {
		for (y = 0;y < CHRHEIGHT;y ++) {
			for (x = 0;x < CHRWIDTH;x ++) {
				pixel[x][y][z] = 0x08;
			}
		}
	}

	z = 0;
	y = 0;
	x = 0;
	c = 0x0a;
	while ( (a0 = fgetc(infp)) != EOF) {

		sft = 0x80;
		for (i = 0;i < 8;i ++) {
			a1 = ( (a0 & sft) != 0x00) ? c : 0x08;
			pixel[x+i][y][z] |= a1;
			sft /= 2;
		}
		x += 8;
		if (x >= CHRWIDTH) {
			x = 0;
			y ++;
			if (y >= CHRHEIGHT) {
				y = 0;
				if (c == 0x0a) {
					c = 0x0c;
				} else {
					c = 0x0a;
					z ++;
					if (z >= cnum) {
						break;
					}
				}
			}
		}
	}


	for (z = 0;z < cnum;z ++) {

		for (x = 0;x < CHRWIDTH;x += 8) {
			for (y = 0;y < CHRHEIGHT;y ++) {

				a1 = 0;
				for (i = 0;i < 8;i ++) {
					a0 = ( ((pixel[x+i][y][z] & 0x02) != 0x00) ? 0x01 : 0x00);
					a1 = a1 * 2 + a0;
				}
				fputc(a1,outfp);

				a1 = 0;
				for (i = 0;i < 8;i ++) {
					a0 = ( ((pixel[x+i][y][z] & 0x04) != 0x00) ? 0x01 : 0x00);
					a1 = a1 * 2 + a0;
				}
				fputc(a1,outfp);

			}
		}
	}



/* 16x8 1v[LN^ */

	cnum = 96;

	for (z = 0;z < cnum;z ++) {
		for (y = 0;y < CHRHEIGHT;y ++) {
			for (x = 0;x < CHRWIDTH;x ++) {
				pixel[x][y][z] = 0x08;
			}
		}
	}

	z = 0;
	y = 0;
	x = 0;
	while ( (a0 = fgetc(infp)) != EOF) {
		sft = 0x80;
		for (i = 0;i < 8;i ++) {
			a1 = ( (a0 & sft) != 0x00) ? 0x0f : 0x08;
			pixel[x+i][y][z] = a1;
			sft /= 2;
		}
		x += 8;
		if (x >= CHRWIDTH) {
			x = 0;
			y ++;
			if (y >= CHRHEIGHT) {
				y = 0;
				z ++;
				if (z >= cnum) {
					break;
				}
			}
		}
	}

	for (z = 0;z < cnum;z ++) {
		for (x = 0;x < CHRWIDTH;x += 8) {
			for (y = 0;y < CHRHEIGHT;y ++) {

				a1 = 0;
				for (i = 0;i < 8;i ++) {
					a0 = ( ((pixel[x+i][y][z] & 0x02) != 0x00) ? 0x01 : 0x00);
					a1 = a1 * 2 + a0;
				}
				fputc(a1,outfp);

			}
		}
	}

	fclose(outfp);
	fclose(infp);

	return(0);
}


