/******************************/
/* 88̉摜66SRpɕϊ */
/******************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	MAXFLLEN	32
#define	MAXWIDTH	640
#define	MAXHEIGHT	200

void	fput2b(int,FILE *);

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;

	unsigned char	pixel[MAXWIDTH][MAXHEIGHT];
	unsigned char	pixel_b[MAXWIDTH/8][MAXHEIGHT*2];

	int		width,height;
	int		width_b,height_b;
	int		a0,a1,a2,a3;
	int		x,y;
	int		i,j;
	int		st;
	int		col,colsr;
	int		ysr;
	int		vram;
	int		staddx,staddy;

	if (argc != 3) {
		fprintf(stderr, "Usage: convpict infile outfile\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	a0 = fgetc(infp);		/* JnAhX */
	a1 = fgetc(infp);		/* JnAhX */

	vram = a1*0x100 + a0 - 0xc000;
	staddy = (vram / 80);
	staddx = (vram - staddy * 80) * 4;

	a0 = fgetc(infp);			/* YTCY */
	a1 = fgetc(infp);			/* YTCY */

	height = (a1*0x100 + a0) / 3;

	width = fgetc(infp) * 8;	/* XTCY */
	fgetc(infp);				/* Jnv[igpj */

	for (y = 0;y < height;y ++) {
		for (x = 0;x < width;x ++) {
			pixel[x][y] = 0x08;
		}
	}

	col = 0x01;

	for (y = 0;y < height;) {
		a0 = fgetc(infp);

		if (a0 >= 0x80) {
			a0 -= 0x80;
			if (a0 >= 0x54) {
				colsr = 0x04;
				a0 -= 0x54;
			} else if (a0 >= 0x2a) {
				colsr = 0x02;
				a0 -= 0x2a;
			} else {
				colsr = 0x01;
			}

			ysr = fgetc(infp);

			for (x = 0;x < width;x ++) {
				if ( (pixel[x][ysr] & colsr) != 0) {
					pixel[x][y] |= col;
				} else {
					pixel[x][y] &= (col ^ 0xff);
				}
			}

			for (x = 0;x < a0*8;) {
				a1 = fgetc(infp);
				if (a1 >= 0xa0) {
					a1 -= 0xa0;
					a2 = 3;
				} else if (a1 >= 0x50) {
					a1 -= 0x50;
					a2 = 2;
				} else {
					a2 = 1;
				}

				for (i = 0;i < a2;i ++) {
					a3 = fgetc(infp);
					st = 0x80;
					for (j = 0;j < 8;j ++) {
						if ( (a3 & st) != 0) {
							pixel[a1*8+j][y] |= col;
						} else {
							pixel[a1*8+j][y] &= (col ^ 0xff);
						}
						st /= 2;
					}
					a1 ++;
					x += 8;
				}

			}

		} else {

			for (x = 0;x < width;) {

				if (x != 0) {
					a0 = fgetc(infp);
				}

				if (a0 >= 0x80) {
					a0 -= 0x80;
					for (i = 0;i < a0;i ++) {
						a1 = fgetc(infp);
						st = 0x80;
						for (j = 0;j < 8;j ++) {
							if ( (a1 & st) != 0) {
								pixel[x+j][y] |= col;
							} else {
								pixel[x+j][y] &= (col ^ 0xff);
							}
							st /= 2;
						}
						x += 8;
					}
				} else {
					a1 = fgetc(infp);
					for (i = 0;i < a0;i ++) {
						st = 0x80;
						for (j = 0;j < 8;j ++) {
							if ( (a1 & st) != 0) {
								pixel[x+j][y] |= col;
							} else {
								pixel[x+j][y] &= (col ^ 0xff);
							}
							st /= 2;
						}
						x += 8;
					}
				}

			}

		}

		if (col == 0x04) {
			col = 0x01;
			y ++;
		} else {
			col *= 2;
		} 

	}

	for (y = 0;y < height;y ++) {
		for (x = 0;x < width;x ++) {
			switch (pixel[x][y]) {
				case 0x08:
					pixel[x][y] = 0x08; break;	/*  */
				case 0x09:
					pixel[x][y] = 0x0e; break;	/*  */
				case 0x0a:
					pixel[x][y] = 0x0a; break;	/*  */
				case 0x0b:
					pixel[x][y] = 0x0a; break;	/* gp */
				case 0x0c:
					pixel[x][y] = 0x0c; break;	/*  */
				case 0x0d:
					pixel[x][y] = 0x0c; break;	/* gp */
				case 0x0e:
					pixel[x][y] = 0x0e; break;	/*  */
				case 0x0f:
					pixel[x][y] = 0x0e; break;	/* gp */
				default:
					break;
			}
		}
	}

/*
	for (y = height-1;y >= 0;y --) {
		for (i = 0;i < 2;i ++) {
			for (x = 0;x < width;x += 2) {
				a0 = (pixel[x][y] & 0x0f) << 4;
				a1 = (pixel[x+1][y] & 0x0f);
				fputc(a0|a1, outfp);
			}
		}
	}
*/

	for (y = 0;y < height;y ++) {
		for (x = 0;x < width;x += 8) {

			a1 = 0x00;
			for (i = 0;i < 8;i ++) {
				a0 = ( ((pixel[x+i][y+0] & 0x02) != 0x00) ? 0x01 : 0x00);
				a1 = a1*2 + a0;
			}
			pixel_b[x/8][y*2+0] = a1;

			a1 = 0x00;
			for (i = 0;i < 8;i ++) {
				a0 = ( ((pixel[x+i][y+0] & 0x04) != 0x00) ? 0x01 : 0x00);
				a1 = a1*2 + a0;
			}
			pixel_b[x/8][y*2+1] = a1;

		}
	}

	height_b = height*2;
	width_b  = width/8;


	fputc(  staddy,  outfp );
	fput2b( staddx,  outfp );
	fputc(  height,  outfp );
	fput2b( width/8, outfp );

	for (y = 0;y < height_b;y ++) {
		for (x = 0;x < width_b;x ++) {
			fputc(pixel_b[x][y], outfp);
		}
	}

	fclose(outfp);
	fclose(infp);

	return(0);
}

void	fput2b(int d,FILE *fp)
{
	int	d0,d1;

	d0 = (d & 0x00ff);
	d1 = (d & 0xff00) >> 8;

	fputc(d0,fp);
	fputc(d1,fp);

	return;
}


